#include <common.h>
#include <arena.h>
#include <syscall.h>

arena arena_init(usize capacity)
{
	void* ptr = mmap(null, capacity, PROT_NONE, MAP_PRIVATE | MAP_ANONYMOUS, -1, 0);
	return (arena){ .ptr = ptr, .available = 0, .capacity = capacity };
}

void arena_ensure(arena* arena, usize available)
{
	if (arena->available >= available) return;

	available = (available + PAGE_SIZE - 1) & -PAGE_SIZE;
	if (available > arena->capacity) {
		available = arena->capacity;
	}

	mprotect((c8*)arena->ptr + arena->available, available - arena->available, PROT_READ | PROT_WRITE);
	arena->available = available;
}
